From df026da68218ef7bd1c050b008f114b0dd5d1145 Mon Sep 17 00:00:00 2001
From: Chris Lamb <chris@chris-lamb.co.uk>
Date: Mon, 7 Jan 2019 19:21:03 +0100
Subject: [PATCH] WIP

---
 Rakefile                                      |  2 +-
 .../generate-tails-builder-box.sh             | 86 +++++++++++++++++++
 2 files changed, 87 insertions(+), 1 deletion(-)

diff --git a/Rakefile b/Rakefile
index eae44c8100..fd6fae4cac 100644
--- a/Rakefile
+++ b/Rakefile
@@ -592,7 +592,7 @@ namespace :basebox do
 
   desc 'Create and import the base box unless already done'
   task :create do
-    next if has_box?
+    #next if has_box?
     $stderr.puts <<-END_OF_MESSAGE.gsub(/^      /, '')
 
       This is the first time we are using this Vagrant base box so we
diff --git a/vagrant/definitions/tails-builder/generate-tails-builder-box.sh b/vagrant/definitions/tails-builder/generate-tails-builder-box.sh
index 40f8f6feee..83526e1fb8 100755
--- a/vagrant/definitions/tails-builder/generate-tails-builder-box.sh
+++ b/vagrant/definitions/tails-builder/generate-tails-builder-box.sh
@@ -22,6 +22,7 @@ get_serial() {
 TARGET_NAME="$(build_setting box_name)"
 TARGET_IMG="${TARGET_NAME}.qcow2"
 TARGET_BOX="${TARGET_NAME}.box"
+TARGET_SPEC="${TARGET_NAME}.vmdb"
 ARCHITECTURE="$(build_setting ARCHITECTURE)"
 DISTRIBUTION="$(build_setting DISTRIBUTION)"
 HOSTNAME="vagrant-${DISTRIBUTION}"
@@ -47,6 +48,91 @@ fi
 # already exists
 rm -f "${TARGET_NAME}".*
 
+cat >${TARGET_SPEC} <<EOF
+# Automatically generated vmdb2(1) specification file
+# for ${TARGET_NAME}.
+#
+# Documentation: <https://vmdb2-manual.liw.fi/>
+
+steps:
+  - mkimg: "{{ output }}"
+    size: 4G
+
+  - mklabel: msdos
+    device: "{{ output }}"
+
+  - mkpart: primary
+    device: "{{ output }}"
+    start: 0%
+    end: 100%
+    part-tag: root-part
+
+  - mkfs: ext4
+    partition: root-part
+
+  - mount: root-part
+    fs-tag: root-fs
+
+
+#steps:
+# - mklabel: msdos
+#   device: "{{ output }}"
+
+# - mkpart: primary
+#   device: "{{ output }}"
+#   start: 0%
+#   end: 100%
+#   tag: root-part
+
+# - mkfs: ext4
+#   partition: root-part
+
+# - debootstrap: 
+#   mirror: http://time-based.snapshots.deb.tails.boum.org/debian/
+#   target: root-fs
+
+  - root-fs: root
+    shell: |
+      debootstrap --keyring="${DEBOOTSTRAP_GNUPG_PUBRING}" "${DISTRIBUTION}" "root" "http://time-based.snapshots.deb.tails.boum.org/debian/${DEBIAN_SERIAL}" 
+
+  - chroot: root-fs
+    shell: |
+      echo ${HOSTNAME} > /etc/hostname
+
+  - grub: bios
+    root-fs: root-fs
+    root-part: root-part
+    console: serial
+
+# TODO
+# "${DEBOOTSTRAP_GNUPG_PUBRING}"
+# --convert-qcow2
+# --enable-dhcp
+# --grub
+# --debootstrapopts ""
+# --owner "${SUDO_USER:-${USER}}"
+# --kernel-package "linux-image-${ARCHITECTURE}"
+# --root-password="${PASSWORD}"
+# --size "${SIZE}"
+# --sudo
+# --user "${USERNAME}/${PASSWORD}"
+# --customize "$(pwd)/customize.sh"
+EOF
+
+cat "${TARGET_SPEC}"
+
+sudo ${http_proxy:+http_proxy="$http_proxy"} \
+     LC_ALL=${LC_ALL} \
+     ARCHITECTURE=${ARCHITECTURE} \
+     DISTRIBUTION=${DISTRIBUTION} \
+     DEBIAN_SERIAL=${DEBIAN_SERIAL} \
+     DEBIAN_SECURITY_SERIAL=${DEBIAN_SECURITY_SERIAL} \
+     TAILS_SERIAL=${TAILS_SERIAL} \
+     echo vmdb2 \
+     "${TARGET_SPEC}" \
+     --output="${TARGET_IMG}" \
+     --verbose
+
 sudo ${http_proxy:+http_proxy="$http_proxy"} \
      LC_ALL=${LC_ALL} \
      ARCHITECTURE=${ARCHITECTURE} \
-- 
2.20.1

